//########## AS50

//### Sound

datablock AudioProfile(gc_as50FireSound)
{
  filename = "./as50.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_as50ReloadSound)
{
  filename = "./as50reload.wav";
  description = AudioClose3d;
  preload = true;
};

//### Projectile

AddDamageType("gc_AS50",'<bitmap:Add-ons/Weapon_GCatsFirearms/AS50/CI_as50> %1','%2 <bitmap:Add-ons/Weapon_GCatsFirearms/AS50/CI_as50> %1',0.2,1);

datablock ProjectileData(gc_as50Projectile)
{
  uiName = "AS 50 Bullet";
  projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
  directDamage = 160;
  directDamageType = $DamageType::gc_AS50;
  radiusDamageType = $DamageType::gc_AS50;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 80;
  brickExplosionMaxVolume = 1;
  brickExplosionMaxVolumeFloating = 2;
  impactImpulse = 175;
  verticalImpulse = 0;
  explosion = gc_bulletExplosion;
  muzzleVelocity = 200; // 350
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 4000;
  fadeDelay = 2000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.25;
  hasLight = false;
  lightRadius = 3;
  lightColor = "1 0.5 0";
};

//### Item

datablock ItemData(gc_as50Item)
{
  uiName = "AS 50";
  iconName = "./icon_as50";
  image = gc_as50Image;
  category = "Weapon";
  className = "Weapon";
  shapeFile = "./as50.dts";
  mass = 4.2;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock ShapeBaseImageData(gc_as50Image)
{
  shapeFile = "./as50.dts";
  emap = true;
  mountPoint = 0;
  offset = "0 0 0";
  correctMuzzleVector = true;
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  className = "WeaponImage";
  item = gc_as50Item;
  ammo = " ";
  projectile = gc_as50Projectile;
  projectileType = Projectile;
  casing = gunShellDebris;
  shellExitDir = "1 -1 0.5";
  shellExitOffset = "0 0 0";
  shellExitVariance = 10;
  shellVelocity = 6;
  melee = false;
  doReaction = false;
  armReady = true;
  minShotTime = 2000;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTimeOut[2] = "Reload";
  stateTimeoutValue[2] = "0.6";
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = gc_gunFlashEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzlePoint";
  stateSound[2] = gc_as50FireSound;
  stateScript[2] = "onFire";

  stateName[3] = "Reload";
  stateTimeoutValue[3] = 0.6;
  stateSequence[3] = "Fire";
  stateTransitionOnTimeout[3] = "Delay";
  stateWaitForTimeout[3] = true;
  stateSound[3] = gc_as50ReloadSound;
  stateEjectShell[3] = true;
  stateAllowImageChange[4] = false;

  stateName[4] = "Delay";
  stateTimeoutValue[4] = 0.2;
  stateTransitionOnTimeout[4] = "Ready";
  stateWaitForTimeout[4] = true;
  stateAllowImageChange[4] = false;
};

function gc_as50Image::onFire(%this,%obj,%slot)
{
  gc_as50ZombiesAmmo(%this,%obj,%slot);
  %obj.gc_as50Ammo -= 1;
  if(%obj.gc_as50Ammo < 1) %obj.setImageAmmo(%slot,0);
  %vector = %obj.getMuzzleVector(%slot);
  %objectVelocity = %obj.getVelocity();
  %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
  %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
  %x = %y = %z = 0;
  %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
  %p = new(%this.projectileType)()
  {
    dataBlock = gc_weaponRecoilHeavy;
    initialVelocity = VectorAdd(%vector1,%vector2);
    initialPosition = %obj.getEyePoint();
    sourceObject = %obj;
    sourceSlot = %slot;
    client = %obj.client;
  };
  %projectile = %this.projectile;
  %spread = 0.00002;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
  }
  return %p;
}

//### Rotondos Ammo Compatibility

function gc_as50ZombiesAmmo(%this,%obj,%slot)
{
  if($AddOn__Gamemode_zombie < 1) return;
  if(isInMinigame(%obj) && %obj.client.minigame.enableAmmoMod == 1)
  {
    if(%this.melee == 1) return;
    if(%obj.zombieammo[%this.projectile] == -1)
    {
      %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE",3);
      return;
    }
    if(%obj.zombieammo[%this.projectile] >= 1)
    {
      %obj.zombieammo[%this.projectile]--;
      bottomPrintRemainingAmmo(%obj, %this);
    }
    if(%obj.zombieammo[%this.projectile] <= 0)
    {
      %obj.zombieammo[%this.projectile] = -1;
      if(isObject(%obj.getMountedImage(0).getName() @ "NoFire"))
      %obj.mountImage(%obj.getMountedImage(0).getName() @ "NoFire",0);
      %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE",3);
      %obj.playAudio(1,ammocratesound);
      %obj.playThread(2,activate2);
      return;
    }
  }
}

function gc_as50Zombies()
{
  $zombie::ammo::Gun[$zombie::ammo::Listcount++] = gc_as50Projectile;
  $zombie::ammo::Ammogc_as50Projectile = 20;
  if(isObject(gunImageNoFire))
  {
    datablock ShapeBaseImageData(gc_as50ImageNoFire : gunImageNoFire)
    {
      shapeFile = "./as50.dts";
      RWep = "gc_as50Image";
      projectile = gc_as50Projectile;
      doColorShift = gc_as50Item.doColorShift;
      colorShiftColor = gc_as50Item.colorShiftColor;
    };
  }
}
schedule(100,0,gc_as50Zombies);

//### Mount on player

datablock ShapeBaseImageData(gc_as50BackImage)
{
  shapeFile = "./as50.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0 -0.35 -0.9";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("65 0 90");
  armReady = false;
  doColorShift = false;
};

function gc_as50Image::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  if(%obj.getMountedImage(1).getName() $= "gc_as50BackImage") { %obj.unMountImage(1); }
}

function gc_as50Image::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
  %obj.mountImage(gc_as50BackImage,1);
}

function gc_as50Item::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(gc_as50BackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package gc_as50Package
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "gc_as50Item")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "gc_as50BackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};
activatepackage(gc_as50Package);
