//########## Axe

//### Sounds

datablock AudioProfile(gc_axeDrawSound)
{
  filename = "./axeDraw.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_axeHitSound)
{
  filename = "./axeHit.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_axeExplosionParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = 1;
  inheritedVelFactor = 0.2;
  constancAccleration = 0;
  spinRandomMin = -180;
  spinRandomMax = 180;
  lifetimeMS = 500;
  lifetimeVarianceMS = 250;
  textureName = "base/data/particles/chunk";
  colors[0] = "0.9 0.8 0.7 1";
  colors[1] = "1 1 1 0";
  sizes[0] = 0.25;
  sizes[1] = 0.5;
};

datablock ParticleEmitterData(gc_axeExplosionEmitter)
{
  uiName = "";
  particles = "gc_axeExplosionParticle";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 8;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 60;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
};

datablock ExplosionData(gc_axeExplosion)
{
  lifeTimeMS = 500;
  soundProfile = gc_axeHitSound;
  particleEmitter = gc_axeExplosionEmitter;
  particleDensity = 10;
  particleRadius = 0.2;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1 1 1";
  camShakeDuration = 1;
  camShakeRadius = 10;
  lightStartRadius = 2;
  lightEndRadius = 0;
  lightStartColor = "0.6 0.4 0.2";
  lightEndColor = "0 0 0";
};

//### Projectile

AddDamageType("gc_Axe",'<bitmap:Add-ons/Weapon_GCatsFirearms/Axe/CI_axe> %1','52 <bitmap:Add-ons/Weapon_GCatsFirearms/Axe/CI_axe> %1',0.75,1);

datablock ProjectileData(gc_axeProjectile)
{
  uiName = "Axe Slice";
  directDamage = 35;
  directDamageType = $DamageType::gc_Axe;
  radiusDamageType = $DamageType::gc_Axe;
  explosion = gc_axeExplosion;
  muzzleVelocity = 50;
  velInheritFactor = 1;
  armingDelay = 0;
  lifetime = 100;
  fadeDelay = 50;
  bounceElasticity = 0;
  bounceFriction = 0;
  isBallistic = false;
  gravityMod = 0;
  hasLight = false;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 5;
  brickExplosionMaxVolume = 1;
  brickExplosionMaxVolumeFloating = 2;
};

//### Item

datablock ItemData(gc_axeItem)
{
  uiName = "Axe";
  iconName = "./icon_axe";
  image = gc_axeImage;
  category = "Weapon";
  className = "Weapon";
  shapeFile = "./axe.dts";
  mass = 2.0;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock ShapeBaseImageData(gc_axeImage)
{
  shapeFile = "./axe.dts";
  emap = true;
  mountPoint = 0;
  offset = "0 0 0";
  correctMuzzleVector = false;
  eyeOffset = "0 0 0";
  className = "WeaponImage";
  item = gc_axeItem;
  ammo = " ";
  projectile = gc_axeProjectile;
  projectileType = Projectile;
  melee = true;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = gc_axeDrawSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[3] = "Fire";
  stateTransitionOnTimeOut[3] = "Ready";
  stateTimeoutValue[3] = "0.3";
  stateFire[3] = true;
  stateAllowImageChange[3] = true;
  stateSequence[3] = "Fire";
  stateScript[3] = "onFire";
  stateWaitForTimeout[3] = true;
};
