//########## Browning HP

//### Sound

datablock AudioProfile(gc_browningFireSound)
{
  filename = "./browning.wav";
  description = AudioClose3d;
  preload = true;
};

//### Projectile

AddDamageType("gc_BrowningHP",'<bitmap:Add-ons/Weapon_GCatsFirearms/BrowningHP/CI_browning> %1','%2 <bitmap:Add-ons/Weapon_GCatsFirearms/BrowningHP/CI_browning> %1',0.2,1);

datablock ProjectileData(gc_browningProjectile)
{
  uiName = "BrowningHP Bullet";
  projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
  directDamage = 30;
  directDamageType = $DamageType::gc_BrowningHP;
  radiusDamageType = $DamageType::gc_BrowningHP;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 20;
  brickExplosionMaxVolume = 1;
  brickExplosionMaxVolumeFloating = 2;
  impactImpulse = 40;
  verticalImpulse = 0;
  explosion = gc_bulletExplosion;
  muzzleVelocity = 80;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 4000;
  fadeDelay = 2000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.25;
  hasLight = false;
  lightRadius = 3;
  lightColor = "1 0.5 0";
};

//### Item

datablock ItemData(gc_browningItem)
{
  uiName = "Browning HP";
  iconName = "./icon_browning";
  image = gc_browningImage;
  category = "Weapon";
  className = "Weapon";
  shapeFile = "./browning.dts";
  mass = 0.9;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock ShapeBaseImageData(gc_browningImage)
{
  shapeFile = "./browning.dts";
  emap = true;
  mountPoint = 0;
  offset = "0 0 0";
  correctMuzzleVector = true;
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  className = "WeaponImage";
  item = gc_browningItem;
  ammo = " ";
  projectile = gc_browningProjectile;
  projectileType = Projectile;
  casing = gunShellDebris;
  shellExitDir = "1 -1 0.5";
  shellExitOffset = "0 0 5";
  shellExitVariance = 10;
  shellVelocity = 6;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTriggerUp[2] = "Ready";
  stateTimeoutValue[2] = "0.3";
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = gc_gunFlashEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzlePoint";
  stateSound[2] = gc_browningFireSound;
  stateScript[2] = "onFire";
  stateEjectShell[2] = true;
  stateSequence[2] = "Fire";
};

function gc_browningImage::onFire(%this,%obj,%slot)
{
  gc_browningZombiesAmmo(%this,%obj,%slot);
  %obj.gc_browningAmmo -= 1;
  if(%obj.gc_browningAmmo < 1) %obj.setImageAmmo(%slot,0);
  %vector = %obj.getMuzzleVector(%slot);
  %objectVelocity = %obj.getVelocity();
  %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
  %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
  %x = %y = %z = 0;
  %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
  %p = new(%this.projectileType)()
  {
    dataBlock = gc_weaponRecoil;
    initialVelocity = VectorAdd(%vector1,%vector2);
    initialPosition = %obj.getEyePoint();
    sourceObject = %obj;
    sourceSlot = %slot;
    client = %obj.client;
  };
  %projectile = %this.projectile;
  %spread = 0.0005;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
  }
  return %p;
}

//### Rotondos Ammo Compatibility

function gc_browningZombiesAmmo(%this,%obj,%slot)
{
  if($AddOn__Gamemode_zombie < 1) return;
  if(isInMinigame(%obj) && %obj.client.minigame.enableAmmoMod == 1)
  {
    if(%this.melee == 1) return;
    if(%obj.zombieammo[%this.projectile] == -1)
    {
      %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE",3);
      return;
    }
    if(%obj.zombieammo[%this.projectile] >= 1)
    {
      %obj.zombieammo[%this.projectile]--;
      bottomPrintRemainingAmmo(%obj, %this);
    }
    if(%obj.zombieammo[%this.projectile] <= 0)
    {
      %obj.zombieammo[%this.projectile] = -1;
      if(isObject(%obj.getMountedImage(0).getName() @ "NoFire"))
      %obj.mountImage(%obj.getMountedImage(0).getName() @ "NoFire",0);
      %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE",3);
      %obj.playAudio(1,ammocratesound);
      %obj.playThread(2,activate2);
      return;
    }
  }
}

function gc_browningZombies()
{
  $zombie::ammo::Gun[$zombie::ammo::Listcount++] = gc_browningProjectile;
  $zombie::ammo::Ammogc_browningProjectile = 40;
  if(isObject(gunImageNoFire))
  {
    datablock ShapeBaseImageData(gc_browningImageNoFire : gunImageNoFire)
    {
      shapeFile = "./browning.dts";
      RWep = "gc_browningImage";
      projectile = gc_browningProjectile;
      doColorShift = gc_browningItem.doColorShift;
      colorShiftColor = gc_browningItem.colorShiftColor;
    };
  }
}
schedule(100,0,gc_browningZombies);
