//########## FN Scar

//### Sound

datablock AudioProfile(gc_fnscarFireSound)
{
  filename = "./fnscar.wav";
  description = AudioClose3d;
  preload = true;
};

//### Projectile

AddDamageType("gc_FNScar",'<bitmap:Add-ons/Weapon_GCatsFirearms/FNScar/CI_fnscar> %1','%2 <bitmap:Add-ons/Weapon_GCatsFirearms/FNScar/CI_fnscar> %1',0.2,1);

datablock ProjectileData(gc_fnscarProjectile)
{
  uiName = "FN Scar Bullet";
  projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
  directDamage = 14;
  directDamageType = $DamageType::gc_FNScar;
  radiusDamageType = $DamageType::gc_FNScar;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 30;
  brickExplosionMaxVolume = 1;
  brickExplosionMaxVolumeFloating = 2;
  impactImpulse = 60;
  verticalImpulse = 0;
  explosion = gc_bulletExplosion;
  muzzleVelocity = 120;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 4000;
  fadeDelay = 2000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.25;
  hasLight = false;
  lightRadius = 3;
  lightColor = "1 0.5 0";
};

//### Item

datablock ItemData(gc_fnscarItem)
{
  uiName = "FN Scar";
  iconName = "./icon_fnscar";
  image = gc_fnscarImage;
  category = "Weapon";
  className = "Weapon";
  shapeFile = "./fnscar.dts";
  mass = 3.8;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock ShapeBaseImageData(gc_fnscarImage)
{
  shapeFile = "./fnscar.dts";
  emap = true;
  mountPoint = 0;
  offset = "0 0 0";
  correctMuzzleVector = true;
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  className = "WeaponImage";
  item = gc_fnscarItem;
  ammo = " ";
  projectile = gc_fnscarProjectile;
  projectileType = Projectile;
  casing = gunShellDebris;
  shellExitDir = "1 -1 0.5";
  shellExitOffset = "0 0 0";
  shellExitVariance = 10;
  shellVelocity = 6;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTimeOut[2] = "Reload";
  stateTimeoutValue[2] = "0.1";
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateSequence[2] = "Fire";
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = gc_gunFlashEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzlePoint";
  stateSound[2] = gc_fnscarFireSound;
  stateEjectShell[2] = true;
  stateScript[2] = "onFire";

  stateName[3] = "Fire2";
  stateTransitionOnTimeOut[3] = "Reload";
  stateTimeoutValue[3] = "0.1";
  stateFire[3] = true;
  stateAllowImageChange[3] = false;
  stateSequence[3] = "Fire";
  stateWaitForTimeout[3] = true;
  stateEmitter[3] = gc_gunFlashEmitter;
  stateEmitterTime[3] = 0.05;
  stateEmitterNode[3] = "muzzlePoint";
  stateSound[3] = gc_fnscarFireSound;
  stateEjectShell[3] = true;
  stateScript[3] = "onFire2";

  stateName[4] = "Reload";
  stateTimeoutValue[4] = 0.01;
  stateTransitionOnTriggerUp[4] = "Ready";
  stateTransitionOnTimeout[4] = "Fire2";
};

function gc_fnscarImage::onFire(%this,%obj,%slot)
{
  gc_fnscarZombiesAmmo(%this,%obj,%slot);
  %obj.gc_fnscarAmmo -= 1;
  if(%obj.gc_fnscarAmmo < 1) %obj.setImageAmmo(%slot,0);
  %vector = %obj.getMuzzleVector(%slot);
  %objectVelocity = %obj.getVelocity();
  %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
  %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
  %x = %y = %z = 0;
  %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
  %p = new(%this.projectileType)()
  {
    dataBlock = gc_weaponRecoil;
    initialVelocity = VectorAdd(%vector1,%vector2);
    initialPosition = %obj.getEyePoint();
    sourceObject = %obj;
    sourceSlot = %slot;
    client = %obj.client;
  };
  %projectile = %this.projectile;
  %spread = 0.0005;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
  }
  return %p;
}

function gc_fnscarImage::onFire2(%this,%obj,%slot)
{
  gc_fnscarZombiesAmmo(%this,%obj,%slot);
  %obj.gc_fnscarAmmo -= 1;
  if(%obj.gc_fnscarAmmo < 1) %obj.setImageAmmo(%slot,0);
  %vector = %obj.getMuzzleVector(%slot);
  %objectVelocity = %obj.getVelocity();
  %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
  %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
  %x = %y = %z = 0;
  %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
  %p = new(%this.projectileType)()
  {
    dataBlock = gc_weaponRecoil;
    initialVelocity = VectorAdd(%vector1,%vector2);
    initialPosition = %obj.getEyePoint();
    sourceObject = %obj;
    sourceSlot = %slot;
    client = %obj.client;
  };
  %projectile = %this.projectile;
  %spread = 0.0015;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
  }
  return %p;
}

//### Rotondos Ammo Compatibility

function gc_fnscarZombiesAmmo(%this,%obj,%slot)
{
  if($AddOn__Gamemode_zombie < 1) return;
  if(isInMinigame(%obj) && %obj.client.minigame.enableAmmoMod == 1)
  {
    if(%this.melee == 1) return;
    if(%obj.zombieammo[%this.projectile] == -1)
    {
      %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE",3);
      return;
    }
    if(%obj.zombieammo[%this.projectile] >= 1)
    {
      %obj.zombieammo[%this.projectile]--;
      bottomPrintRemainingAmmo(%obj, %this);
    }
    if(%obj.zombieammo[%this.projectile] <= 0)
    {
      %obj.zombieammo[%this.projectile] = -1;
      if(isObject(%obj.getMountedImage(0).getName() @ "NoFire"))
      %obj.mountImage(%obj.getMountedImage(0).getName() @ "NoFire",0);
      %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE",3);
      %obj.playAudio(1,ammocratesound);
      %obj.playThread(2,activate2);
      return;
    }
  }
}

function gc_fnscarZombies()
{
  $zombie::ammo::Gun[$zombie::ammo::Listcount++] = gc_fnscarProjectile;
  $zombie::ammo::Ammogc_fnscarProjectile = 90;
  if(isObject(gunImageNoFire))
  {
    datablock ShapeBaseImageData(gc_fnscarImageNoFire : gunImageNoFire)
    {
      shapeFile = "./fnscar.dts";
      RWep = "gc_fnscarImage";
      projectile = gc_fnscarProjectile;
      doColorShift = gc_fnscarItem.doColorShift;
      colorShiftColor = gc_fnscarItem.colorShiftColor;
    };
  }
}
schedule(100,0,gc_fnscarZombies);

//### Mount on player

datablock ShapeBaseImageData(gc_fnscarBackImage)
{
  shapeFile = "./fnscar.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "-0.1 -0.35 -0.45";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("75 0 90");
  armReady = false;
  doColorShift = false;
};

function gc_fnscarImage::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  if(%obj.getMountedImage(1).getName() $= "gc_fnscarBackImage") { %obj.unMountImage(1); }
}

function gc_fnscarImage::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
  %obj.mountImage(gc_fnscarBackImage,1);
}

function gc_fnscarItem::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(gc_fnscarBackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package gc_fnscarPackage
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "gc_fnscarItem")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "gc_fnscarBackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};
activatepackage(gc_fnscarPackage);
