//########## RPG-7

//### Sounds

datablock AudioProfile(gc_rpg7FireSound)
{
  filename = "./rpg7Fire.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_rpg7LoopSound)
{
  filename = "./rpg7Loop.wav";
  description = AudioDefaultLooping3d;
  preload = true;
};

//### Effects

datablock ExplosionData(gc_rpg7Explosion)
{
  soundProfile = gc_grapefruitExplosionSound;
  lifeTimeMS = 150;
  particleEmitter = gc_grapefruitSmokeEmitter;
  particleDensity = 10;
  particleRadius = 0.2;
  emitter[0] = gc_grapefruitExplosionEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "10 10 10";
  camShakeAmp = "3 10 3";
  camShakeDuration = 0.5;
  camShakeRadius = 10;
  lightStartRadius = 10;
  lightEndRadius = 5;
  lightStartColor = "1 0.6 0.2 1";
  lightEndColor = "1 0 0 0";
  damageRadius = 10;
  radiusDamage = 150;
  impulseRadius = 5;
  impulseForce = 2500;
};

//### Projectile

AddDamageType("gc_RPG7",'<bitmap:Add-ons/Weapon_GCatsFirearms/RPG7/CI_rpg7> %1','%2 <bitmap:Add-ons/Weapon_GCatsFirearms/RPG7/CI_rpg7> %1',0.2,1);
AddDamageType("gc_RPG7Radius",'<bitmap:Add-ons/Weapon_GCatsFirearms/RPG7/CI_rpg7radius> %1','%2 <bitmap:Add-ons/Weapon_GCatsFirearms/RPG7/CI_rpg7radius> %1',0.2,1);

datablock ProjectileData(gc_rpg7Projectile)
{
  uiName = "RPG-7 Rocket";
  projectileShapeName = "./rpg7rocket.dts";
  directDamage = 80;
  directDamageType = $DamageType::gc_RPG7;
  radiusDamageType = $DamageType::gc_RPG7Radius;
  brickExplosionRadius = 5;
  brickExplosionImpact = false;
  brickExplosionForce = 30;
  brickExplosionMaxVolume = 120;
  brickExplosionMaxVolumeFloating = 120;
  impactImpulse = 1000;
  verticalImpulse = 100;
  explosion = gc_rpg7Explosion;
  particleEmitter = rocketTrailEmitter;
  muzzleVelocity = 60;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 3000;
  fadeDelay = 3000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.05;
  explodeOnDeath = true;
  hasLight = true;
  lightRadius = 3;
  lightColor = "1 0.5 0";
  sound = gc_rpg7LoopSound;
};

//### Item

datablock ItemData(gc_rpg7Item)
{
  uiName = "RPG-7";
  iconName = "./icon_rpg7";
  image = gc_rpg7Image;
  category = "Weapon";
  className = "Weapon";
  shapeFile = "./rpg7.dts";
  mass = 0.9;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock ShapeBaseImageData(gc_rpg7Image)
{
  shapeFile = "./rpg7.dts";
  emap = true;
  mountPoint = 0;
  offset = "0 0 0";
  correctMuzzleVector = true;
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  className = "WeaponImage";
  item = gc_rpg7Item;
  ammo = " ";
  projectile = gc_rpg7Projectile;
  projectileType = Projectile;
  melee = false;
  doReaction = false;
  armReady = true;
  minShotTime = 2900;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTimeOut[2] = "Smoke";
  stateTimeoutValue[2] = "0.05";
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = rocketLauncherSmokeEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "tailPoint";
  stateSound[2] = gc_rpg7FireSound;
  stateScript[2] = "onFire";

  stateName[3] = "Smoke";
  stateTimeoutValue[3] = 0.05;
  stateEmitter[3] = rocketLauncherSmokeEmitter;
  stateEmitterTime[3] = 0.05;
  stateEmitterNode[3] = "muzzleNode";
  stateTransitionOnTimeout[3] = "Reload";
  stateAllowImageChange[3] = false;
  stateWaitForTimeout[3] = true;

  stateName[4] = "Reload";
  stateTimeoutValue[4] = 2.9;
  stateSequence[4] = "Fire";
  stateTransitionOnTimeout[4] = "Ready";
  stateWaitForTimeout[4] = true;
  stateAllowImageChange[4] = false;
};

function gc_rpg7Image::onFire(%this,%obj,%slot)
{
  gc_rpg7ZombiesAmmo(%this,%obj,%slot);
  %obj.gc_rpg7Ammo -= 1;
  if(%obj.gc_rpg7Ammo < 1) %obj.setImageAmmo(%slot,0);
  Parent::onFire(%this,%obj,%slot);
}

//### Rotondos Ammo Compatibility

function gc_rpg7ZombiesAmmo(%this,%obj,%slot)
{
  if($AddOn__Gamemode_zombie < 1) return;
  if(isInMinigame(%obj) && %obj.client.minigame.enableAmmoMod == 1)
  {
    if(%this.melee == 1) return;
    if(%obj.zombieammo[%this.projectile] == -1)
    {
      %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE",3);
      return;
    }
    if(%obj.zombieammo[%this.projectile] >= 1)
    {
      %obj.zombieammo[%this.projectile]--;
      bottomPrintRemainingAmmo(%obj, %this);
    }
    if(%obj.zombieammo[%this.projectile] <= 0)
    {
      %obj.zombieammo[%this.projectile] = -1;
      if(isObject(%obj.getMountedImage(0).getName() @ "NoFire"))
      %obj.mountImage(%obj.getMountedImage(0).getName() @ "NoFire",0);
      %obj.client.bottomPrint("<just:center><color:FFFF00>Ammo <color:FFFFFF>: <just:left><color:FF0000> NONE",3);
      %obj.playAudio(1,ammocratesound);
      %obj.playThread(2,activate2);
      return;
    }
  }
}

function gc_rpg7Zombies()
{
  $zombie::ammo::Gun[$zombie::ammo::Listcount++] = gc_rpg7Projectile;
  $zombie::ammo::Ammogc_rpg7Projectile = 5;
  if(isObject(gunImageNoFire))
  {
    datablock ShapeBaseImageData(gc_rpg7ImageNoFire : gunImageNoFire)
    {
      shapeFile = "./rpg7.dts";
      RWep = "gc_rpg7Image";
      projectile = gc_rpg7Projectile;
      doColorShift = gc_rpg7Item.doColorShift;
      colorShiftColor = gc_rpg7Item.colorShiftColor;
    };
  }
}
schedule(100,0,gc_rpg7Zombies);

//### Mount on player

datablock ShapeBaseImageData(gc_rpg7BackImage)
{
  shapeFile = "./rpg7.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "-0.4 -0.35 0";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("65 0 90");
  armReady = false;
  doColorShift = false;
};

function gc_rpg7Image::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  if(%obj.getMountedImage(1).getName() $= "gc_rpg7BackImage") { %obj.unMountImage(1); }
}

function gc_rpg7Image::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
  %obj.mountImage(gc_rpg7BackImage,1);
}

function gc_rpg7Item::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(gc_rpg7BackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package gc_rpg7Package
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "gc_rpg7Item")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "gc_rpg7BackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};
activatepackage(gc_rpg7Package);
