//### Effects

datablock AudioProfile(gc_bulletHitSound)
{
  filename = "./bulletImpact.wav";
  description = AudioClose3d;
  preload = true;
};

datablock ParticleData(gc_bulletExplosionParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.5";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 0.5;
  sizes[1] = 2;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_bulletExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_bulletExplosionParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_bulletExplosionRingParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 35;
  textureName = "base/data/particles/star1";
  spinSpeed = 500;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 0 0.9";
  colors[1] = "0.9 0 0 0";
  sizes[0] = 1;
  sizes[1] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_bulletExplosionRingEmitter)
{
  uiName = "";
  lifeTimeMS = 50;
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_bulletExplosionRingParticle";
  useEmitterColors = true;
};

datablock ExplosionData(gc_bulletExplosion)
{
  soundProfile = gc_bulletHitSound;
  lifeTimeMS = 150;
  particleEmitter = gc_bulletExplosionEmitter;
  particleDensity = 5;
  particleRadius = 0.2;
  emitter[0] = gc_bulletExplosionRingEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = false;
  camShakeFreq = "10 11 10";
  camShakeAmp = "1 1 1";
  camShakeDuration = 0.5;
  camShakeRadius = 10;
  lightStartRadius = 0;
  lightEndRadius = 2;
  lightStartColor = "1 0.6 0.2";
  lightEndColor = "0 0 0";
};

datablock ExplosionData(gc_weaponRecoilExplosion)
{
  lifeTimeMS = 1;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "1 1 1";
  camShakeAmp = "0.1 0.1 0.1";
  camShakeDuration = 0.5;
  camShakeRadius = 0.1;
};

datablock ProjectileData(gc_weaponRecoil)
{
  uiName = "";
  explosion = gc_weaponRecoilExplosion;
  muzzleVelocity = 0;
  velInheritFactor = 1;
  lifetime = 1;
  fadeDelay = 1;
  explodeOnDeath = true;
};

datablock ExplosionData(gc_weaponRecoilExplosionHeavy)
{
  lifeTimeMS = 1;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "1 1 1";
  camShakeAmp = "0.2 0.2 0.2";
  camShakeDuration = 0.6;
  camShakeRadius = 0.1;
};

datablock ProjectileData(gc_weaponRecoilHeavy)
{
  uiName = "";
  explosion = gc_weaponRecoilExplosionHeavy;
  muzzleVelocity = 0;
  velInheritFactor = 1;
  lifetime = 1;
  fadeDelay = 1;
  explodeOnDeath = true;
};

datablock ParticleData(gc_gunFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 30;
  lifetimeVarianceMS = 0;
  textureName = "./muzzle";
  spinSpeed = 10;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 1 0.5";
  colors[1] = "1 0.5 0 0.5";
  colors[2] = "1 0 0 0.5";
  sizes[0] = 2.5;
  sizes[1] = 1;
  sizes[2] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_gunFlashEmitter)
{
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 50;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 1;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_gunFlashParticle";
  uiName = "Gun Flash 2";
};
